<template>
    <NuxtLayout :name="'dashboard'">
        <div class="container p-8">
            <!-- <Toast :visible="toastVisible" :title="toastTitle" :message="toastMessage" /> -->
            <CustomTable :tableName="tableName" :currentPage="currentPage" :limitPerPage="itemPerPage" :heads="heads"
                :items="outcomes" :addPath="!isWarga ? '/funding/new' : ''" @on-search="search"
                @approve-funding="approveFunding" @reject-funding="rejectFunding" @page-change="pageUpdate" />
        </div>
    </NuxtLayout>
</template>

<script lang="ts">

definePageMeta({
    middleware: ["auth"],
});

export default {
    layout: "dashboard",
    data() {
        return {
            toastVisible: false,
            toastTitle: "",
            toastMessage: "",
            fundingId: '',
            tableName: "Funding",
            isLoading: false,
            currentPage: 1,
            itemPerPage: 10,
            heads: [
                "No",
                "Nama Pengeluaran",
                "Harga",
            ],
            outcomes: [] as { key: string, value: string }[],
        };
    },
    mounted() {
        this.fundingId = this.$route.params.funding_id as string;
        this.fetchData();
    },
    computed: {
        isWarga: () => {
            const userStore = useUserDataStore();
            return userStore.role === 'warga' ? true : false;
        }
    },
    methods: {
        fetchData(query: string = '') {
            this.isLoading = true;
            const userDataStore = useUserDataStore();
            const userId = userDataStore.id;
            const toastStore = useToastStore();
            const accessToken = localStorage.getItem("access_token");
            const config = useRuntimeConfig();
            this.$api
                .get(`/funding/${this.fundingId}`, {
                    headers: {
                        'Authorization': `Bearer ${accessToken}`,
                    },
                })
                .then((response) => {
                    let reportData = response.data.report.split(';');
                    let formatedList: { key: string, value: string }[] = [];

                    reportData.forEach((item: any) => {
                        let keyValue = item.split(':');
                        // Ensure the key and value are present before pushing to formatedList
                        if (keyValue.length === 2) {
                            let formattedItem = {
                                key: keyValue[0].trim(),   // Trim to remove leading/trailing whitespaces
                                value: keyValue[1].trim()
                            };
                            formatedList.push(formattedItem);
                        }
                    });

                    this.outcomes = formatedList;
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    toastStore.showToast(message, 'danger');
                }).finally(() => {
                    this.isLoading = false;
                })
        },
        search(query: string) {
            this.fetchData(query);
        },
        pageUpdate(page: number) {
            this.currentPage = page;
            this.fetchData();
        },
        approveFunding(id: number) {
            this.isLoading = true;
            const toastStore = useToastStore();
            const accessToken: string = localStorage.getItem("access_token")!;
            this.$api.put(`/funding/${id}/approve`, {}, {
                headers: {
                    'Authorization': `Bearer ${accessToken}`,
                },
            })
                .then((response) => {
                    console.log(response)
                    let title = response.data.title;
                    this.fetchData();
                    toastStore.showToast(`Funding ${title} has been approved`, 'success');
                    this.isLoading = false;
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    this.fetchData();
                    toastStore.showToast(message, 'danger');
                    this.isLoading = false;
                })
        },
        rejectFunding(id: number) {
            this.isLoading = true;
            const toastStore = useToastStore();
            const accessToken: string = localStorage.getItem("access_token")!;
            this.$api.put(`/funding/${id}/reject`, {}, {
                headers: {
                    'Authorization': `Bearer ${accessToken}`,
                },
            })
                .then((response) => {
                    console.log(response)
                    let title = response.data.title;
                    this.fetchData();
                    toastStore.showToast(`Funding ${title} has been rejected`, 'success');
                    this.isLoading = false;
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    this.fetchData();
                    toastStore.showToast(message, 'danger');
                    this.isLoading = false;
                })
        },
    },
};
</script>
